%
% OnlineModel demo for a simple line
% 

% define mypath and start adding the necessary libraries
% UPDATE THESE PATHs according to your setup!!!!
myPath = '/user/ctf3op/davideg/work/onlineModel/demo';
addpath(fullfile(myPath,'../../madx2MatlabLib'));
addpath(fullfile(myPath,'../../onlineModel'));
cd(myPath);

% define madx script and executables
madxScriptFile = fullfile(myPath,'./generalScript.madx');
madxParameterFile = fullfile(myPath,'./nominalcurrents.txt');
madxExecutableFile = fullfile(myPath,'./madx64');

correctorsCurrents = {...
    ... % CT line
    'CT.IDHD0160',...
    'CT.IDHD0308',...
    'CT.IDHD0360',...
    'CT.IDHE0255',...
    'CT.IDHE0420',...
    'CT.IDHE0470',...
    'CT.IDHF0365',...
    ...
    'CT.IDVD0160',...
    'CT.IDVD0360',...
    'CT.IDVE0245',...
    'CT.IDVE0410',...
    'CT.IDVE0480',...
    'CT.IDVF0365',...
    };
quadrupoleCurrents = {...
    %... CT line
    'CT.IQDD0110',...
    'CT.IQFD0130',...
    'CT.IQFD0150',...
    'CT.IQDD0220',...
    'CT.IQFE0230',...
    'CT.IQDF0245',...
    'CT.IQFE0250',...
    'CT.IQFD0310',...
    'CT.IQFD0330',...
    'CT.IQDD0350',...
    'CT.IQDF0410',...
    'CT.IQFF0420',...
    'CT.IQDF0470',...
    'CT.IQFF0480',...
    };
%% create the real object
myModel = onlineModel(madxScriptFile, madxParameterFile, 'ctf3demo', 'backctf3demo', madxExecutableFile);
% setup conversion database properly for our CTF3
myModel.machineModel.conversionMapDatabase = ctf3elementsDatabaseGenerator();

% define list of quadrupoles currents
myModel.quadrupoleCurrents = upper(quadrupoleCurrents);
myModel.correctorsCurrents = upper(correctorsCurrents);

% define initial beta values
myModel.initialBETX = 7.9545;
myModel.initialBETY = 11.5067;
myModel.initialALFX = -0.10198;
myModel.initialALFY = -2.4088;


%% if one want to use PTC
usePTC = false;
if usePTC
    % define a differet twiss command
    myModel.machineModel.twissCommandLine=[...
        'PTCNSTEPS := 3;',char(10),...
        'select, flag=twiss, clear;',char(10),...
        'select, flag=twiss, column=name, KEYWORD, s, x, y, px, py, l, k1l, energy,', char(10),...
        'beta11,beta22,alfa11,alfa22,betx,bety,alfx,alfy,',char(10),...
        'disp1,disp2,disp3,disp4, mu1,mu2,',char(10),...
        'ptcsigx, ptcsigy, ptcsigp;',char(10),...
        'ptc_create_universe;',char(10),...
        'ptc_create_layout,resplit,xbend, model=2, method=6, nst=PTCNSTEPS, exact=true, closed_layout=false;',char(10),...
        'ptc_setswitch, debuglevel=0, nocavity=false,',char(10),...
        'maxacceleration=true, fringe=true, exact_mis=true, time=true, totalpath=true;',char(10),...
        'ptc_eplacement, range=CR.PTCinjMarker, x= crInjectionOffset,  y=0, z=0, onlyposition, refframe=previouselement, autoplacedownstream=true;',char(10),...
        'ptc_eplacement, range=CR.PTCextMarker, x= crExtractionOffset, y=0, z=0, onlyposition, refframe=previouselement, autoplacedownstream=true;',char(10),...
        'PTC_TWISS, table=twiss, icase=6, no=2, betz=1.0,',char(10),...
        'BETX=initialBETX,ALFX=initialALFX,',char(10),...
        'BETY=initialBETY,ALFY=initialALFY,',char(10),...
        'DX=initialDX,DPX=initialDPX,DY=initialDY,DPY=initialDPY,',char(10),...
        'X=initialX,PX=initialPX,Y=initialY,PY=initialPY,',char(10),...
        'DELTAP=initialDELTAP;',char(10),...
        'ptc_end;',char(10),...
        ];
    
    % setup PTC CR injection/extraction offsets
    crInjectionOffset = -0.0364;
    crExtractionOffset = 0.02185639167;
    myModel.machineModel.setModelParameters('crInjectionOffset', crInjectionOffset);
    myModel.machineModel.setModelParameters('crExtractionOffset', crExtractionOffset);
end


%% start the GUI

possibleMeasurementPositions = {...
    'CT.qscanQDF0410',...
    };

if usePTC
    onlineModelGUI(myModel, possibleMeasurementPositions, 'PTCtwiss');
else
    onlineModelGUI(myModel, possibleMeasurementPositions);
end

return
